package onig4j;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author calico
 */
public class OnigSyntaxTypeTest {

    @Test
    public void clinit() {
        long tm = System.currentTimeMillis();
        OnigSyntaxType syntax = OnigSyntaxType.ONIG_SYNTAX_ASIS;
        
        System.out.println(System.currentTimeMillis() - tm);
    }

    @Test
    public void isBuiltIn() {
        for (final OnigSyntaxType syntax : OnigSyntaxType.values()) {
            assertTrue(syntax.isBuiltIn());
        }
        
        OnigSyntaxType syntax = OnigSyntaxType.ONIG_SYNTAX_ASIS.clone();
        assertFalse(syntax.isBuiltIn());
    }
    
    @Test
    public void close() throws InterruptedException {
        for (final OnigSyntaxType syntax : OnigSyntaxType.values()) {
            syntax.close();
            assertTrue(syntax.handle != 0);
        }
        
        OnigRegex regex = null;
        OnigSyntaxType syntax = null;
        
        regex = new OnigRegex("abc", OnigSyntaxType.ONIG_SYNTAX_ASIS);
        assertSame(OnigSyntaxType.ONIG_SYNTAX_ASIS, regex.getSyntaxType());        

        syntax = OnigSyntaxType.ONIG_SYNTAX_ASIS.clone();
        regex = new OnigRegex("abc", syntax);
        final OnigSyntaxType syn = regex.getSyntaxType();
        assertEquals(syntax, syn);
        assertSame(syntax, syn);
        
        if (syntax != null) {
            syntax.close();
            syntax = null;
        }

        Thread.sleep(1000);
        System.gc();
        
        int ret = regex.search("aaabccc");
        assertEquals(2, ret);
        
        ret = regex.search("aabcccc");
        ret = regex.search("abccc");
        ret = regex.search("aaaaaaaaaaabc");
        assertNotNull(regex.getSyntaxType());
        
//        assertEquals(OnigSyntaxType.ONIG_SYNTAX_ASIS.handle, handle);        
    }

//    @Test
//    public void hashCode_() {
//        OnigRegex regex = null;
//        OnigSyntaxType syntax = null;
//        
//        regex = new OnigRegex("abc", OnigSyntaxType.ONIG_SYNTAX_ASIS);
//        assertEquals(OnigSyntaxType.ONIG_SYNTAX_ASIS.hashCode(), regex.getSyntaxType().hashCode());
//        
//        syntax = OnigSyntaxType.ONIG_SYNTAX_ASIS.clone();
//        regex = new OnigRegex("abc", syntax);
//        OnigSyntaxType syntax2 = regex.getSyntaxType();
//        assertEquals(syntax.hashCode(), syntax2.hashCode());
//        assertFalse(syntax == syntax2);
//        assertTrue(syntax.equals(syntax2));
//    }
}